typedef struct QTYPE {
    int count;
    int front;
    int rear;
    int elemsize;
    int maxsize;
    char *data;
} QTYPE;

typedef struct VTBLTYPE {
    char *vname;
    int value;
} VTBLTYPE;

typedef struct NTBLTYPE {
    char     *pname;
	VTBLTYPE *vtblentry;
    int      *p_value;
    VTBLTYPE *p_vtable;
    int      vtblsize;
} NTBLTYPE;

/* Function prototypes from SERIAL.C */

/* Use interrupt attribute to define C function as interrupt handler */

void interrupt cdecl far s_mainhndlr ( void );
int s_setup ( void );
static void s_intinit ( void ); 
void s_cleanup ( void );
static void s_intoff ( void );
void s_setcommparams ( void );
int s_setvals( char *name, char *vals );
char *s_getvals( char *name );
int s_sendchar( int ch );
int s_rcvchar ( void );
int s_txqempty ( void );
void s_sendbreak ( void );
void s_delay( double d_ms );

/* From QPAC.C */

QTYPE *q_setup ( unsigned maxsize, unsigned elemsize );
void q_reset ( QTYPE *queue );
char *q_getfrom ( QTYPE *queue, char  *data );
int q_puton ( QTYPE *queue, char  *data );

